// CNet Amiga/4 Programming examples
// copyright  1998 Ray A. Akey
// Exclusive license granted to ZenMetal Software and CNet door coders.


struct Library      *CNetCBase = NULL; // CNetC library base
struct Library      *CNet4Base = NULL;	// CNet4 library base
struct CNetCContext *context   = NULL;	// CNetCContext contains MainPort, current PortData etc.

struct PortData     *z   = NULL; // pointer into context for PortData; just for ease of using z instead of context->z
struct MainPort     *myp = NULL; // pointer into context for MainPort; same idea as for z above


int intGetOut( void )
{
	exit(0);
	return 0;
}

// Exit/cleanup code goes in here
void GetOut(void)
{

   // ------------------- YOUR CLEANUP CODE STARTS HERE - IF ANY -----------------





   // -------------------- CNETC DOOR SHUTDOWN PROCEDURE BEGINS ------------------
	if(context)
		{
	   CNC_ShutDown(NULL);
		CNC_DisposeContext();
		context=NULL;
		}
	if(CNetCBase)
		{
		CloseLibrary(CNetCBase);
		CNetCBase=NULL;
		}
	if(CNet4Base)
		{
		CloseLibrary(CNet4Base);
		CNet4Base=NULL;
		}
}


void main(int argc, char **argv)
{
	LONG zzz=0;
	char date[40];

	// ---------------------- CHECK IF RAN AS A CNETC DOOR ---------------------
   if(argc < 2)
   	{
      Printf("This is a CNetC Program!\n");
      return;
   	}
   	
   // ----------------------- CNETC DOOR SETUP STARTS HERE --------------------
	atexit(GetOut);
	onbreak(intGetOut); // install a ^C trap

   if( !(CNetCBase = OpenLibrary("cnetc.library", 4)) ) // library required for ALL CNetC doors.
   	GetOut();
   if( !(CNet4Base = OpenLibrary("cnet4.library", 4)) ) // library required for CalculateAge() and other date-related routines
   	GetOut();
   if( !(context = CNC_InitContext(argv[1])) )
   	GetOut();
	z=context->z;
   myp=context->myp;


	// -------------------------- YOUR CODE BEGINS HERE ------------------------



	// ---------------------- PRINT SOME CURRENT USER DATAS. ----------------------

	CNC_PutText("\n");
	sprintf(z->ABuffer, "   Your Handle: %s\n", z->user1.Handle);
	CNC_PutA();
	sprintf(z->ABuffer, "Your Real name: %s\n", z->user1.RealName);
	CNC_PutA();
	sprintf(z->ABuffer, "      Your age: %d\n\n", CalculateAge(&z->user1));
	CNC_PutA();


	// ------------- MAKE PRINTABLE DATE OUT OF CNET IsDate STRUCTURE. --------------

	// CNetPrintDate() is a cnet4.library function.
	//
	CNetPrintDate(&z->user1.LastCall, date, NULL, NULL);
	sprintf(z->ABuffer, "     Last Call: %s\n", date);
	CNC_PutA();
	CNetPrintDate(&z->user1.Birthdate, date, NULL, NULL);
	sprintf(z->ABuffer, "     Birthdate: %s\n\n", date);
	CNC_PutA();
		
	
	// --------------------------- SHOW LOADED PORTS. -----------------------------

	CNC_PutText("Loaded ports\n---------------------\n");
	for(zzz=0;zzz<100;zzz++)
		{
		if(IsPortLoaded(zzz))
			{
			sprintf(z->ABuffer, "%3d: %s\n", zzz, IsPortOccupied(zzz) ? myp->PortZ[zzz]->user1.Handle : "[IDLE]");
			CNC_PutA();
			}
		}


	//  ---- SIMPLY PRINT A NEWLINE - SAME AS CNC_PutText("\n") OR CNC_PutText("n1") ---

	CNC_DoReturn();


	// ---------------- ASK USER IF HE/SHE WANTS TO DO AN EDITOR TEST. -------------

	if(CNC_PutQ("Do editor test now? [Y/n] ?1"))
		{
		// YES!

			//  ------ sample editor usage - load systext:menu/main into editor first. ---
			{
			BPTR fh;
			char edfile[128];

			// open existing source file
			if(fh=Open("systext:menu/main", MODE_OLDFILE))
				{
				// fill editor with contents of file belonging to file handle "fh".

				// PrepEditor() is a cnet.lib function.
				PrepEditor(fh);

				// Allow user to edit editor file.
				// allow 255 lines and use existing _edbuffX file contents.
				CNC_CallEditor(255, TRUE);

				// create the CNet editor filename for the current port
				// MakeEd() is a cnet.lib function
				MakeEd(edfile);

				// read the editor file and print file not found if it does not exist.
				CNC_ReadFile(edfile, TRUE);

				// close the source file.
				Close(fh);
				}
			}
		
		}
	else
		{
		// NO!
		CNC_PutText("Editor test skipped\n");
		}


	// ------------------------------- ENTERLINE USAGE -----------------------
	//
	{
	BOOL done = FALSE;

	while(!done)
		{
		if(CNC_EnterLine(10, ELINE_INPUTBOX, "\nEnter 'YES' or 'NO': ")) // see io.h for enterline flags
			{
			if(!stricmp(z->InBuffer, "YES"))
				{
				CNC_PutText("Alright, you agree - so what?!\n");
				done = TRUE; // flag to quit loop
				}
			else if(!stricmp(z->InBuffer, "NO"))
				{
				CNC_PutText("Awwwwww, you suck!\n");
				done = TRUE; // flag to quit loop
				}
			else
				{
				CNC_PutText("Uhmmm..  You DO know english, correct?\n");
				}
			}
		else
			{
			CNC_PutText("I said 'YES' or 'NO'!!\n");
			}
		}
	}


	// ---------------------------- ONEKEY USAGE ---------------------------
	{
	char vowels[] = "aeiou"; // string of characters
	short zzz=0; // temp variable
	char key;	

	while(vowels[zzz]) // while a valid character is indexed
		{
		do
			{
			// prepare a string to be printed in z->ABuffer
			sprintf(z->ABuffer, "\nPress '%c': ", vowels[zzz]);

			// Print z->ABuffer
			CNC_PutA();

			// get a key from the user
			// note that by default, CNC_OneKey returns UPPERCASE character input.
         // to make it return lowercase input, set z->NoCaseConvert = TRUE
         // and then set it back after getting your key input.

			z->NoCaseConvert = TRUE;
			key=CNC_OneKey();
			z->NoCaseConvert = FALSE;

			} while(key != vowels[zzz]);
		zzz++;
		}
	CNC_PutText("\nGood, you got through all the vowels!\n");
	}

	// a similar version of the above code, using CNC_PutQMult()
	{
	char vowels[] = "aeiou"; // string of characters
	short zzz=0; // temp variable
	char key;
	char choices[2] = { 0,0 };

	while(vowels[zzz]) // while a valid character is indexed
		{
		// prepare a string to be printed in z->ABuffer
		sprintf(z->ABuffer, "\nPress '%c': ", vowels[zzz]);
		choices[0] = vowels[zzz];

		// Print z->ABuffer
		z->NoCaseConvert = TRUE;
		key=CNC_PutQMult(z->ABuffer, choices);

		sprintf(z->ABuffer, "User pressed '%c'", choices[key-1]);
		CNC_PutA();

		z->NoCaseConvert = FALSE;
		zzz++;
		}
	CNC_PutText("\nGood, you got through all the vowels!\n");
	}

	// -------------------------- END OF YOUR MAIN CODE ------------------------


   exit(0); // exit back to CNet
}

