// CNet Amiga/4 Programming examples
// copyright  1998 Ray A. Akey
// Exclusive license granted to ZenMetal Software and CNet door coders.

#include <pragmas/cnetc_pragmas.h>
#include <libraries/cnetc_library.h>

struct Library      *CNetCBase = NULL;
struct Library      *CNet4Base = NULL;
struct CNetCContext *context   = NULL;

struct PortData     *z   = NULL;
struct MainPort     *myp = NULL;


// Exit/cleanup code goes in here
void GetOut(void)
{

   // ------------------- YOUR CLEANUP CODE STARTS HERE - IF ANY -----------------





   // -------------------- CNETC DOOR SHUTDOWN PROCEDURE BEGINS ------------------
	if(context)
		{
	   CNC_ShutDown(NULL);
		CNC_DisposeContext();
		context=NULL;
		}
	if(CNetCBase)
		{
		CloseLibrary(CNetCBase);
		CNetCBase=NULL;
		}
	if(CNet4Base)
		{
		CloseLibrary(CNet4Base);
		CNet4Base=NULL;
		}
}


void main(int argc, char **argv)
{
	LONG zzz=0;

	// ---------------------- CHECK IF RAN AS A CNETC DOOR ---------------------
   if(argc < 2)
   	{
      Printf("This is a CNetC Program!\n");
      return;
   	}
   	
   // ----------------------- CNETC DOOR SETUP STARTS HERE --------------------
	atexit(GetOut);
   if( !(CNetCBase = OpenLibrary("cnetc.library", 4)) ) // library required for ALL CNetC doors.
   	GetOut();
   if( !(CNet4Base = OpenLibrary("cnet4.library", 4)) ) // library required for CalculateAge() and other date-related routines
   	GetOut();
   if( !(context = CNC_InitContext(argv[1])) )
   	GetOut();
	z=context->z;
   myp=context->myp;


	// -------------------------- YOUR CODE BEGINS HERE ------------------------

	CNC_PutText("\n");
	sprintf(z->ABuffer, "   Your Handle: %s\n", z->user1.Handle);
	CNC_PutA();
	sprintf(z->ABuffer, "Your Real name: %s\n", z->user1.RealName);
	CNC_PutA();
	sprintf(z->ABuffer, "      Your age: %d\n\n", CalculateAge(&z->user1));
	CNC_PutA();
	
	CNC_PutText("Loaded ports\n---------------------\n");
	for(zzz=0;zzz<100;zzz++)
		{
		if(IsPortLoaded(zzz))
			{
			sprintf(z->ABuffer, "%3d: %s\n", zzz, IsPortOccupied(zzz) ? myp->PortZ[zzz]->user1.Handle : "[IDLE]");
			CNC_PutA();
			}
		}

	// -------------------------- END OF YOUR MAIN CODE ------------------------


   exit(0); // exit back to CNet
}

