
/*
 * These are the assembler "bni" functions defined in this file.
 * They are mostly hand-optimised Amiga GCC compiler code.
 */

#define bniMulAdd1_32 bniMulAdd1_32


#define	ENTRY(x) asm(".text; .globl _" #x "; .even; _" #x ":");

/*
 * BNWORD32
 * bniMulAdd1_32 (BNWORD32 *out asm("a0"),
 *				  BNWORD32 const *in asm("a1"),
 *				  unsigned len asm("d6"),
 *				  BNWORD32 k asm("d7"))
 */

ENTRY(bniMulAdd1_32)
asm("
      	linkw %fp,#0
      	moveml %d3-%d7/%a2-%a3,%sp@-
      	moveal %fp@(8),%a0		/* *out */
      	moveal %fp@(12),%a1		/* *in */
      	movel %fp@(16),%d6		/* len */
      	movel %fp@(20),%d7		/* k */

      	movel %a1@+,%d0     	/* Get contents of a0 into d0 */
      	mulul %d7,%d3,%d0
      	moveal %d3,%a2      	/* get address in d3 into a2 */
      	moveal %d0,%a3			/* get address in d0 into a3 */
      	movel %a0@,%d1      	/* get contents of a0 into d1 */
      	clrl %d0            	/* clear d0 for addx.l d0,d3 later */
      	movel %a2,%d3
      	movel %a3,%d4
      	addl %d1,%d4        	/* These two lines become 64 bit addition... */
      	addxl %d0,%d3       	/* add d0,d1 to d3,d4 */
      	movel %d3,%d1       	/* d1 = d3 */
      	movel %d4,%a0@+     	/* put d4 into (a0)+ */
      	bras count

loop:
		movel %a1@+,%d0     	/* d0 = (a1)+ */
		mulul %d7,%d4,%d0
		movel %d4,%d3       	/* d3 = d4 */
		movel %d0,%d4       	/* d4 = d0 */
		movel %d1,%d1			/* set d1 for extended addition */
		clrl %d0				/* set d0 for extended addition */
		addl %d1,%d4        	/* These two lines are 64 bit addition... */
		addxl %d0,%d3       	/* They add d0,d1 to d3,d4 */
		movel %a0@,%d1      	/* get contents of a0 into d1 */
		clrl %d0				/* set d0 for extended addition */
		addl %d1,%d4        	/* These two lines are 64 bit addition... */
		addxl %d0,%d3       	/* They add d0,d1 to d3,d4 */
		movel %d3,%d1       	/* d1 = d3 */
		movel %d4,%a0@+     	/* put d4 into (a0)+ */

count:
		subql #1,%d6        	/* decrement d6 */
		bnes loop           	/* loop until 0 */

		movel %d1,%d0       	/* d0 = d1 */
		moveml %fp@(-28),%d3-%d7/%a2-%a3	/* restore registers */
		unlk %fp				/* unlink frame pointer */

		rts                 	/* return */
");

#if 0
ENTRY(bniMulSub1_32)
asm("
		linkw %fp,#0
		moveml %d2-%d7/%a2-%a3,%sp@-
		moveal %fp@(8),%a1
		moveal %fp@(12),%a2
		movel %fp@(16),%d5
		moveal %fp@(20),%a3
		movel %a2@+,%d0
		movel %a3,%d2
		mulul %d0,%d1,%d2
		bras 2d4 <_bniMulSub1_32+3a>
2bc:
		movel %a2@+,%d0
		movel %a3,%d4
		mulul %d0,%d3,%d4
		movel %d1,%d1
		clrl %d0
		movel %d3,%d6
		movel %d4,%d7
		addl %d1,%d7
		addxl %d0,%d6
		movel %d6,%d1
		movel %d7,%d2
2d4:
		moveal %a1@,%a0
		movel %a0,%d0
		subl %d2,%d0
		movel %d0,%a1@+
		movel %d1,%d1
		cmpal %d0,%a0
		bccs 2e4 <_bniMulSub1_32+4a>

		addql #1,%d1

2e4:
		subql #1,%d5
		bnes 2bc <_bniMulSub1_32+22>

		movel %d1,%d0
		moveml %fp@(-32),%d2-%d7/%a2-%a3
		unlk %fp
		rts
");
#endif